function MainAssistant() {
	/* this is the creator function for your scene assistant object. It will be passed all the 
	   additional parameters (after the scene name) that were passed to pushScene. The reference
	   to the scene controller (this.controller) has not be established yet, so any initialization
	   that needs the scene controller should be done in the setup function below. */
}

MainAssistant.prototype.setup = function() {

this.categoryChanged = this.categoryChanged.bindAsEventListener(this);
this.valueChanged = this.valueChanged.bind(this);
this.checkNumber = this.checkNumber.bind(this);

Mojo.Event.listen(this.controller.get("categoryList"), Mojo.Event.propertyChange, this.categoryChanged);
Mojo.Event.listen(this.controller.get("fromList"), Mojo.Event.propertyChange, this.valueChanged);
Mojo.Event.listen(this.controller.get("toList"), Mojo.Event.propertyChange, this.valueChanged);
Mojo.Event.listen(this.controller.get("inputValue"), Mojo.Event.propertyChange, this.valueChanged);

var catCount = 0;
var unitCount = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];

this.conversions = [ 
{label:"Area", value: catCount++, units:[
{label:"Acres",              value: unitCount[catCount]++, conv: 4046.8564224},
{label:"Hectares",           value: unitCount[catCount]++, conv: 10000},
{label:"Square centimeters", value: unitCount[catCount]++, conv: 0.0001},
{label:"Square feet",        value: unitCount[catCount]++, conv: 0.09290304},
{label:"Square inches",      value: unitCount[catCount]++, conv: 0.00064516},
{label:"Square kilometers",  value: unitCount[catCount]++, conv: 1000000},
{label:"Square meters",      value: unitCount[catCount]++, conv: 1.0},
{label:"Square miles",       value: unitCount[catCount]++, conv: 2589988.110336},
{label:"Square millimeters", value: unitCount[catCount]++, conv: 0.000001},
{label:"Square yards",       value: unitCount[catCount]++, conv: 0.83612736},
			       ]},
{label:"Length", value:catCount++, units:[
{label:"Angstroms",          value:unitCount[catCount]++, conv: 0.0000000001},
{label:"Astronomical Units", value:unitCount[catCount]++, conv: 149598550000},
{label:"Centimeters",        value:unitCount[catCount]++, conv: 0.01},
{label:"Cubits",             value:unitCount[catCount]++, conv: 0.4572},
{label:"Fathoms",            value:unitCount[catCount]++, conv: 1.8288},
{label:"Feet",               value:unitCount[catCount]++, conv: 0.3048},
{label:"Furlongs",           value:unitCount[catCount]++, conv: 201.168},
{label:"Hands",              value:unitCount[catCount]++, conv: 0.1016},
{label:"Inches",             value:unitCount[catCount]++, conv: 0.0254},
{label:"Kilometers",         value:unitCount[catCount]++, conv: 1000},
{label:"Leagues",            value:unitCount[catCount]++, conv: 5556},
{label:"Light years",        value:unitCount[catCount]++, conv: 9460500000000000},
{label:"Meters",             value:unitCount[catCount]++, conv: 1.0},
{label:"Microns",            value:unitCount[catCount]++, conv: 0.000001},
{label:"Miles",              value:unitCount[catCount]++, conv: 1609.344},
{label:"Miles (nautical)",   value:unitCount[catCount]++, conv: 1852},
{label:"Millimeters",        value:unitCount[catCount]++, conv: 0.001},
{label:"Nanometers",         value:unitCount[catCount]++, conv: 0.000000001},
{label:"Parsecs",            value:unitCount[catCount]++, conv: 30856770000000000},
{label:"Rods",               value:unitCount[catCount]++, conv: 5.0292},
{label:"Yards",              value:unitCount[catCount]++, conv: 0.9144}
                                ]},
{label:"Mass", value:catCount++, units:[
{label:"Carats",        value:unitCount[catCount]++, conv: 0.0002},
{label:"Grains",        value:unitCount[catCount]++, conv: 0.00006479891},
{label:"Grams",         value:unitCount[catCount]++, conv: 0.001},
{label:"Kilograms",     value:unitCount[catCount]++, conv: 1.0},
{label:"Ounces",        value:unitCount[catCount]++, conv: 0.028349523125},
{label:"Ounces (troy)", value:unitCount[catCount]++, conv: 0.0311034768},
{label:"Pounds",        value:unitCount[catCount]++, conv: 0.45359237},
{label:"Stones",        value:unitCount[catCount]++, conv: 6.35029318},
{label:"Tons (UK)",     value:unitCount[catCount]++, conv: 1016.0469088},
{label:"Tons (US)",     value:unitCount[catCount]++, conv: 907.18474},
{label:"Tonnes",        value:unitCount[catCount]++, conv: 1000}
			       ]},
{label:"Speed", value:catCount++, units:[
{label:"Centimeters/Minute", value:unitCount[catCount]++, conv:1/6000},
{label:"Centimeters/Second", value:unitCount[catCount]++, conv:1/100},
{label:"Feet/Hour",          value:unitCount[catCount]++, conv:1/11811},
{label:"Feet/Minute",        value:unitCount[catCount]++, conv:0.00508},
{label:"Feet/Second",        value:unitCount[catCount]++, conv:0.3048},
{label:"Inches/Minute",      value:unitCount[catCount]++, conv:1/2362.2},
{label:"Inches/Second",      value:unitCount[catCount]++, conv:0.0254},
{label:"Kilometers/Hour",    value:unitCount[catCount]++, conv:1/3.6},
{label:"Kilometers/Second",  value:unitCount[catCount]++, conv:1000},
{label:"Knots",              value:unitCount[catCount]++, conv:0.514444},
{label:"Mach",               value:unitCount[catCount]++, conv:331.5},
{label:"Meters/Hour",        value:unitCount[catCount]++, conv:1/3600},
{label:"Meters/Minute",      value:unitCount[catCount]++, conv:1/60},
{label:"Meters/Second",      value:unitCount[catCount]++, conv:1},
{label:"Miles/Hour",         value:unitCount[catCount]++, conv:0.44704},
{label:"Miles/Minute",       value:unitCount[catCount]++, conv:26.8224},
{label:"Miles/Second",       value:unitCount[catCount]++, conv:1609.344},
{label:"Yards/Hour",         value:unitCount[catCount]++, conv:1/3937},
{label:"Yards/Minute",       value:unitCount[catCount]++, conv:0.01524},
{label:"Yards/Second",       value:unitCount[catCount]++, conv:0.9144}
				]},
{label:"Storage", value:catCount++, units:[
{label:"Bits",      value: unitCount[catCount]++, conv: 0.125},
{label:"Bytes",     value: unitCount[catCount]++, conv: 1.0},
{label:"Exabits",   value: unitCount[catCount]++, conv: 1000000000000000000/8},
{label:"Exabytes",  value: unitCount[catCount]++, conv: 1000000000000000000},
{label:"Exbibits",  value: unitCount[catCount]++, conv: 1152921504606846976/8},
{label:"Exbibytes", value: unitCount[catCount]++, conv: 1152921504606846976},
{label:"Gibibits",  value: unitCount[catCount]++, conv: 1073741824/8},
{label:"Gibibytes", value: unitCount[catCount]++, conv: 1073741824},
{label:"Gigabits",  value: unitCount[catCount]++, conv: 1000000000/8},
{label:"Gigabytes", value: unitCount[catCount]++, conv: 1000000000},
{label:"Kibibits",  value: unitCount[catCount]++, conv: 128},
{label:"Kibibytes", value: unitCount[catCount]++, conv: 1024},
{label:"Kilobits",  value: unitCount[catCount]++, conv: 125},
{label:"Kilobytes", value: unitCount[catCount]++, conv: 1000},
{label:"Mebibits",  value: unitCount[catCount]++, conv: 131072},
{label:"Mebibytes", value: unitCount[catCount]++, conv: 1048576},
{label:"Megabits",  value: unitCount[catCount]++, conv: 125000},
{label:"Megabytes", value: unitCount[catCount]++, conv: 1000000},
{label:"Pebibits",  value: unitCount[catCount]++, conv: 1125899910000000/8},
{label:"Pebibytes", value: unitCount[catCount]++, conv: 1125899910000000},
{label:"Petabits",  value: unitCount[catCount]++, conv: 1000000000000000/8},
{label:"Petabytes", value: unitCount[catCount]++, conv: 1000000000000000},
{label:"Tebibits",  value: unitCount[catCount]++, conv: 1099511627776/8},
{label:"Tebibytes", value: unitCount[catCount]++, conv: 1099511627776},
{label:"Terabits",  value: unitCount[catCount]++, conv: 1000000000000/8},
{label:"Terabytes", value: unitCount[catCount]++, conv: 1000000000000},
					   ]}, 
{label:"Temperature", value:catCount++, units:[
{label:"Celsius",    value:unitCount[catCount]++, conv: 1.0},
{label:"Fahrenheit", value:unitCount[catCount]++, conv: 1.0},
{label:"Kelvin",     value:unitCount[catCount]++, conv: 1.0}
				      ]},
{label:"Time", value:catCount++, units:[
{label:"Centuries",    value:unitCount[catCount]++, conv: 36524.2199},
{label:"Days",         value:unitCount[catCount]++, conv: 1.0},
{label:"Decades",      value:unitCount[catCount]++, conv: 3652.42199},
{label:"Fortnights",   value:unitCount[catCount]++, conv: 14},
{label:"Hours",        value:unitCount[catCount]++, conv: 1/24},
{label:"Millenia",     value:unitCount[catCount]++, conv: 365242.199},
{label:"Milliseconds", value:unitCount[catCount]++, conv: 1/86400000},
{label:"Minutes",      value:unitCount[catCount]++, conv: 1/1440},
{label:"Months",       value:unitCount[catCount]++, conv: 30.4368499},
{label:"Quarters",     value:unitCount[catCount]++, conv: 91.25},
{label:"Seconds",      value:unitCount[catCount]++, conv: 1/86400},
{label:"Shakes",       value:unitCount[catCount]++, conv: 1/8640000000000},
{label:"Weeks",        value:unitCount[catCount]++, conv: 7},
{label:"Years",        value:unitCount[catCount]++, conv: 365.242199}
				      ]},
{label:"Volume", value:catCount++, units:[
{label:"Barrels (oil)",        value:unitCount[catCount]++, conv: 158.987294928},
{label:"Bushels (UK)",         value:unitCount[catCount]++, conv: 36.36872},
{label:"Bushels (US)",         value:unitCount[catCount]++, conv: 35.23907016688},
{label:"Centiliters",          value:unitCount[catCount]++, conv: 0.01},
{label:"Cubic Centimeters",    value:unitCount[catCount]++, conv: 0.001},
{label:"Cubic Decimeters",     value:unitCount[catCount]++, conv: 1.0},
{label:"Cubit Feet",           value:unitCount[catCount]++, conv: 28.316846592},
{label:"Cubic Inches",         value:unitCount[catCount]++, conv: 0.016387064},
{label:"Cubic Meters",         value:unitCount[catCount]++, conv: 1000},
{label:"Cubic Millimeters",    value:unitCount[catCount]++, conv: 0.000001},
{label:"Cubic Yards",          value:unitCount[catCount]++, conv: 764.554857984},
{label:"Cups",                 value:unitCount[catCount]++, conv: 0.236588236},
{label:"Deciliters",           value:unitCount[catCount]++, conv: 0.1},
{label:"Fluid Ounces (UK)",    value:unitCount[catCount]++, conv: 0.0284130625},
{label:"Fluid Ounces (US)",    value:unitCount[catCount]++, conv: 0.0295735295625},
{label:"Gallons (UK)",         value:unitCount[catCount]++, conv: 4.54609},
{label:"Gallons, Dry (US)",    value:unitCount[catCount]++, conv: 4.40488377086},
{label:"Gallons, Liquid (US)", value:unitCount[catCount]++, conv: 3.785411784},
{label:"Kegs",                 value:unitCount[catCount]++, conv: 58.6738827},
{label:"Liters",               value:unitCount[catCount]++, conv: 1.0},
{label:"Milliliters",          value:unitCount[catCount]++, conv: 0.001},
{label:"Pints (UK)",           value:unitCount[catCount]++, conv: 0.56826125},
{label:"Pints, Dry (US)",      value:unitCount[catCount]++, conv: 0.5506104713575},
{label:"Pints, Liquid (US)",   value:unitCount[catCount]++, conv: 0.473176473},
{label:"Quarts (UK)",          value:unitCount[catCount]++, conv: 1.1365225},
{label:"Quarts, Dry (US)",     value:unitCount[catCount]++, conv: 1.101220942715},
{label:"Quarts, Liquid (US)",  value:unitCount[catCount]++, conv: 0.946352946},
{label:"Tablespoon (UK)",      value:unitCount[catCount]++, conv: 0.0177581714},
{label:"Tablespoon (US)",      value:unitCount[catCount]++, conv: 0.0147867648},
{label:"Teaspoon (UK)",        value:unitCount[catCount]++, conv: 0.00591939047},
{label:"Teaspoon (US)",        value:unitCount[catCount]++, conv: 0.00492892159},
				 ]}];

this.prefsCookie = new Mojo.Model.Cookie("unitsPrefs"); 
this.prefs = this.prefsCookie.get();
if (!this.prefs){
    this.prefs = {category: 0, from: 0, to: 1};
}

this.categoryModel = {value: this.prefs.category};
this.fromModel = {choices: this.conversions[this.prefs.category].units, value: this.prefs.from};
this.toModel = {choices: this.conversions[this.prefs.category].units, value: this.prefs.to};
this.valueModel = {value : 0};

this.controller.setupWidget(Mojo.Menu.commandMenu,{spacerHeight: 0,menuClass: 'no-fade'},
			    {visible: true,items: [ 
						   { },
						   { iconPath: 'images/menu-icon-switch.png', command: 'switch'}
						    ]
				    });			    

this.controller.setupWidget("categoryList", {label:"Category", choices: this.conversions},this.categoryModel);
this.controller.setupWidget("fromList", {label:"From"},this.fromModel);
this.controller.setupWidget("toList", {label:"To"},this.toModel);
this.controller.setupWidget("switchButton",{},{label :"Switch From/To",disabled: false});

this.controller.setupWidget("inputValue", {changeOnKeyPress: true, modifierState: Mojo.Widget.numLock,
	    charsAllow: this.checkNumber}, this.valueModel);

this.valueChanged(0);
}

MainAssistant.prototype.handleCommand = function(event) {
    if(event.type == Mojo.Event.command) {
	switch(event.command) {
	    
	case "switch":
	var fromVal = this.fromModel.value;
	this.fromModel.value = this.toModel.value;
	this.toModel.value = fromVal;
	
	this.controller.modelChanged(this.fromModel, this);
	this.controller.modelChanged(this.toModel, this);
	
	this.valueChanged(event);
	break;
	}
    }
}

MainAssistant.prototype.checkNumber = function(event) {
    if ((event >= 48 && event <= 57) || event == 46 || event == 45) return true;
    return false;
}
	
MainAssistant.prototype.valueChanged = function(event) {
    if (this.conversions[this.categoryModel.value].label == "Temperature") {
	if (this.fromModel.value == 1) {
	    celsius = (this.valueModel.value - 32) * 5 / 9;
	} else if (this.fromModel.value == 2) {
	    celsius = this.valueModel.value*1 - 273.15;
	} else {
	    celsius = this.valueModel.value;
	}
	if (this.toModel.value == 0) {
	    result = celsius;
	} else if (this.toModel.value == 1) {
	    result = ((celsius * 9)/5) + 32;
	} else {
	    result = celsius*1 + 273.15;
	}
    } else {
	result = (this.valueModel.value * this.fromModel.choices[this.fromModel.value].conv)/this.toModel.choices[this.toModel.value].conv;
    }
    if (result < 10000000000) { result = Math.round(result * 10000000000) / 10000000000; }
    this.controller.get("inputTitle").update("Enter value in "+ this.fromModel.choices[this.fromModel.value].label + "...");
    this.controller.get("resultTitle").update("Result in "+ this.toModel.choices[this.toModel.value].label + "...");
    this.controller.get("resultValue").update(result);

    this.prefsCookie.put({category: this.categoryModel.value, 
		from: this.fromModel.value, 
		to: this.toModel.value});
}

MainAssistant.prototype.categoryChanged = function(event) {
    this.fromModel.choices = this.conversions[this.categoryModel.value].units;
    this.toModel.choices = this.conversions[this.categoryModel.value].units;
    this.fromModel.value = 0;
    this.toModel.value = 1;
    this.valueChanged(event);

    this.controller.modelChanged(this.fromModel, this);
    this.controller.modelChanged(this.toModel, this);
}

MainAssistant.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
}


MainAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
}

MainAssistant.prototype.cleanup = function(event) {
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
}
